%{?scl:%scl_package rubygem-%{gem_name}}
%{!?scl:%global pkg_name %{name}}

%global app_root /var/www/miq
%global doc_root %{_datadir}/%{name}-doc

Name:     cfme
Version:  5.4.1.0
Release:  1%{?dist}
Summary:  CloudForms Management Engine

Group:    Applications/System
License:  Unknown
URL:      https://github.com/ManageIQ/manageiq

Source0:  cfme-%{version}.tar.gz

BuildRequires: openslp-devel
BuildRequires: scl-utils-build
BuildRequires: ruby200-ruby
BuildRequires: ruby200-ruby-devel
BuildRequires: ruby200-rubygems-devel
BuildRequires: cfme-gemset

Requires: %{?scl_prefix}ruby(release)
Requires: %{?scl_prefix}ruby(rubygems)
Requires: %{?scl_prefix}ruby

Requires: OpenIPMI
Requires: cfme-lib
Requires: createrepo
Requires: freeipmi
Requires: fuse-libs
Requires: httpd
Requires: ipmitool
Requires: lshw
Requires: memcached
Requires: mod_ssl
Requires: net-snmp
Requires: net-snmp-libs
Requires: net-snmp-utils
Requires: nfs-utils
Requires: nodejs010-nodejs
Requires: patch
Requires: portmap
Requires: prince
Requires: qpid-cpp-client-ssl
Requires: wmi

# IPA Identity RPMs for External Authentication
Requires: c-ares >= 1.7.0
Requires: ipa-admintools >= 3.0.0
Requires: ipa-client >= 3.0.0
Requires: mod_intercept_form_submit >= 0.9.7
Requires: mod_auth_kerb >= 5.4
Requires: mod_authnz_pam >= 0.9.2
Requires: mod_lookup_identity >= 0.9.2

Requires: cfme-gemset = %{version}
Requires: yum-utils

Requires: %{?scl_prefix}rubygem-bcrypt-ruby = 3.0.1
Requires: %{?scl_prefix}rubygem-eventmachine = 1.0.7
Requires: %{?scl_prefix}rubygem-ffi = 1.9.8
Requires: %{?scl_prefix}rubygem-io-extra = 1.2.8
Requires: %{?scl_prefix}rubygem-json = 1.8.2
Requires: %{?scl_prefix}rubygem-nokogiri = 1.5.11
Requires: %{?scl_prefix}rubygem-pg = 0.12.2
Requires: %{?scl_prefix}rubygem-psych = 2.0.13
Requires: %{?scl_prefix}rubygem-qpid_messaging = 0.20.2
Requires: %{?scl_prefix}rubygem-therubyracer = 0.11.0
Requires: %{?scl_prefix}rubygem-thin = 1.3.1

%description
CloudForms Management Engine

%package lib
Summary:   CloudForms Management Engine libraries
Group:     Applications/Internet
License:   GPLv2+ and Apache Public License 2.0
Requires: %{name} = %{version}-%{release}
BuildRequires: netapp-manageability-sdk-devel
BuildRequires: openssl-devel
BuildRequires: zlib-devel

%description lib
CloudForms Management Engine libraries

%package appliance
Summary:  CloudForms Management Engine appliance configuration
Group:    Applications/Internet
License:  Unknown
Requires: %{name} = %{version}-%{release}
Requires: postgresql92-postgresql
Requires: postgresql92-postgresql-server
Requires: sssd >= 1.11.6
Requires: sssd-dbus >= 1.11.6

%description appliance
Appliance-only configuration and scripts

%prep
%setup -q

%build
export GEM_HOME="/opt/rh/cfme-gemset"
export PATH=$GEM_HOME/bin:$PATH
/usr/bin/scl enable ruby200 "rake build:shared_objects --trace"

%pre

%pretrans -p <lua>
if posix.access('/sbin/service', 'x') then
  if posix.access('/etc/init.d/evmserverd', 'r') then
    local pid = posix.fork ()
    if ( pid == -1 ) then
      print ("The fork failed.")
    elseif ( pid == 0 ) then
      posix.exec('/sbin/service', 'evmserverd', 'update_stop')
    else
      posix.wait(pid)
    end
  end
end

%posttrans -p <lua>
if posix.access('/sbin/service', 'x') then
  if posix.access('/etc/init.d/evmserverd', 'r') then
    local pid = posix.fork ()
    if ( pid == -1 ) then
      print ("The fork failed.")
    elseif ( pid == 0 ) then
      posix.exec('/sbin/service', 'evmserverd', 'update_start')
    else
      posix.wait(pid)
    end
  end
end

%install

%{__mkdir} -p %{buildroot}
%{__mkdir} -p %{buildroot}%{app_root}
%{__cp} Rakefile %{buildroot}%{app_root}
%{__cp} -r system %{buildroot}%{app_root}
%{__cp} -r vmdb %{buildroot}%{app_root}
%{__cp} -r lib %{buildroot}%{app_root}
# %{__cp} -r ca %{buildroot}%{app_root}
find %{buildroot}%{app_root}/lib -type f -name '*.[cho]' -exec rm -f '{}' \;
%{__mkdir} -p %{buildroot}%{app_root}/vmdb/log/apache
%{__mkdir} -p %{buildroot}%{_sysconfdir}/httpd/conf.d

#symlink some executables
%{__mkdir} -p %{buildroot}/bin
pushd ./system/LINK/bin
  for filename in `ls`; do
    ln -s %{app_root}/system/LINK/bin/$filename %{buildroot}/bin/$filename
  done
popd

#symlink some configuration files
pushd ./system/LINK/etc
  for dirname in `ls`; do
    pushd ./$dirname
      %{__mkdir} -p %{buildroot}/etc/$dirname
      for filename in `ls`; do
        ln -s %{app_root}/system/LINK/etc/$dirname/$filename %{buildroot}/etc/$dirname/$filename
      done
    popd
  done
popd

pushd ./system/LINK
  ln -s %{app_root}/system/LINK/.toprc %{buildroot}/.toprc
popd

#symlink license file for prince PDF
%{__mkdir} -p %{buildroot}/lib/prince/license
ln -s %{app_root}/system/LINK/lib/prince/license/license.dat %{buildroot}/lib/prince/license/license.dat

#copy etc dir from COPY
%{__cp} -r ./system/COPY/etc %{buildroot}/

#copy var dir from COPY
%{__cp} -r ./system/COPY/var %{buildroot}/

%post

#Ensure pre-5.4 external auth configuration is honored with the new 5.4 layout.
httpd_conf_dir=/etc/httpd/conf.d
pre_http_external_auth=${httpd_conf_dir}/cfme-external-auth
http_external_auth=${httpd_conf_dir}/cfme-external-auth.conf
http_remote_user_template=%{app_root}/system/TEMPLATE/etc/httpd/conf.d/cfme-remote-user.conf

if [ ! -f ${http_external_auth} -a -f /etc/sssd/sssd.conf -a -f ${http_remote_user_template} ]
then
  if [ -f ${pre_http_external_auth} ]
  then
    %{__cp} ${pre_http_external_auth} ${http_external_auth}
  fi
  %{__cp} ${http_remote_user_template} ${httpd_conf_dir}/cfme-remote-user.conf
fi

%postun

%clean
rm -rf $RPM_BUILD_ROOT

%files
%defattr(-,root,root,-)
%dir %{app_root}
# %{app_root}/ca
%{app_root}/vmdb
%config(noreplace) %{app_root}/vmdb/certs/*
%{app_root}/system
%{app_root}/Rakefile
/bin/appliance_console
/bin/appliance_console_cli
/bin/evm_watchdog
/bin/evm_watchdog.rb
/bin/fix_auth
/bin/miqnet.sh
/bin/miqtop.sh
/etc/default/evm
/etc/default/evm_bundler
/etc/default/evm_productization
/etc/init.d/evminit
/etc/init.d/evmserverd
/etc/init.d/miqtop
/.toprc
/etc/logrotate.d/miq_logs.conf
/etc/profile.d/evm.sh
/lib/prince/license/license.dat
/var/www/html/proxy_pages/invalid_sso_credentials.js

%files lib
%defattr(-,root,root,-)
%{app_root}/lib

%files appliance
%defattr(-,root,root,-)
/etc/init/*
/etc/httpd/conf.d/*

%changelog
* Fri Jul 17 2015 Satoe Imaishi <simaishi@redhat.com> - 5.4.1.0-1
- Building 5.4.1.0-1 for 5.4.z

* Fri Jun 05 2015 John Prause <jprause@redhat.com> - 5.4.0.5-1
- Building 5.4.0.5 for QE

* Fri May 29 2015 John Prause <jprause@redhat.com> - 5.4.0.4-1
- Building 5.4.0.4 for QE

* Tue May 26 2015 John Prause <jprause@redhat.com> - 5.4.0.3-1
- Building 5.4.0.3 for QE

* Tue May 19 2015 John Prause <jprause@redhat.com> - 5.4.0.2-1
- Building 5.4.0.2 for QE

* Wed May 13 2015 John Prause <jprause@redhat.com> - 5.4.0.1-1
- Building 5.4.0.1 for QE

* Mon May 11 2015 John Prause <jprause@redhat.com> - 5.4.0.0.26-1
- Building 5.4.0.0.26

* Mon May 04 2015 John Prause <jprause@redhat.com> - 5.4.0.0.25-1
- Building 5.4.0.0.25

* Thu Apr 30 2015 Alberto Bellotti <abellott@redhat.com> - 5.4.0.0.24-2
- Added new %post section to make sure external authentication configuration is migrated.

* Tue Apr 28 2015 John Prause <jprause@redhat.com> - 5.4.0.0.24-1
- Updated to version 5.4.0.0-ga-test3

* Wed Apr 23 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0.23-1
- Updated to version 5.4.0.0-ga-test2

* Wed Apr 22 2015 Mo Morsi <mmorsi@redhat.com> - 5.4.0.0.22-2
- Split out individual vmdb files, mark certs as config
- Fix date in changelog

* Mon Apr 20 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.22-1
- Revert to original Gemfiles after gemset creation

* Sat Apr 18 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.21-1
- Updated to version 5.4.0.0-ga-test1

* Fri Apr 10 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.19-1
- Updated Gemfiles to not lock down the compiled gems versions

* Thu Apr 09 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.18-1
- Update to beta2b build including the compiled gems

* Thu Apr 09 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.17-1
- Update to beta2b build

* Mon Apr 06 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.15-1
- Move compiled gems from cfme-gemset into individual RPMs

* Fri Mar 27 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.14-3
- Test build for incorporating the iptables using iptables.old

* Wed Mar 25 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.14-2
- Add incorporating the iptables updates

* Wed Mar 25 2015 John Prause <jprause@redhat.com> 5.4.0.0.14-1
- Buillding 5.4.0.0 beta1 third respin

* Fri Mar 20 2015 John Prause <jprause@redhat.com> 5.4.0.0.13-1
- Buillding 5.4.0.0 beta1 second respin

* Mon Mar 16 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.12-3
- Add the wmi package

* Mon Mar 16 2015 Joe VLcek <jvlcek@redhat.com> 5.4.0.0.12-2
- Add the patch package

* Tue Mar 10 2015 John Prause <jprause@redhat.com> - 5.4.0.0.12-1
- Respin of Beta1 build

* Tue Mar 10 2015 John Prause <jprause@redhat.com> - 5.4.0.0.11-1
- Beta1 build - Sprint20

* Thu Feb 19 2015 John Prause <jprause@redhat.com> - 5.4.0.0.10-1
- Alpha4 build - Sprint19

* Thu Feb 12 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0.9-2
- Add qpid_messaging

* Fri Feb 06 2015 John Prause <jprause@redhat.com> - 5.4.0.0.9
- First 5.4 build for JP

* Wed Feb 04 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-8
- Remove Gemfile.lock link
- Revise 5.4.0.0-alpha3

* Mon Feb 02 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-7
- Add file evm_productization
- Revise 5.4.0.0-7.alpha2

* Mon Jan 26 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-6
- cfme-gemset moved to /opt/rh

* Mon Jan 26 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-5
- Add Rakefile to app_root

* Wed Jan 21 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-4
- Set app_root to /var/www/miq

* Wed Jan 21 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-3
- Update to leave git locations in Gemfile

* Fri Jan 16 2015 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-2
- Update to using cfme-gemset

* Fri Dec 19 2014 Joe VLcek <jvlcek@redhat.com> - 5.4.0.0-1
- Remove Smart Proxy, ming
- Update from 5.3 to 5.4
- Migrate from ruby193 to ruby200
- Update for any gem changes
- use scl macro

* Mon Dec 08 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.2.2-3
- Use updated gemfile.lock now provided in cfme_productization

* Mon Dec 08 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.2.2-3
- Use updated gemfile.lock now provided in cfme_productization

* Thu Dec 04 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.2.2-2
- Revert req for sssd and sssd-dbus to 1.11.6

* Thu Dec 04 2014 John Prause <jprause@redhat.com> - 5.3.2.2-1
- Added necessary gem rpm to the advisory

* Wed Dec 03 2014 John Prause <jprause@redhat.com> - 5.3.2.1-2
- Updated req for sssd and sssd-dbus to 1.11.6-30

* Wed Dec 03 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.2.1-1
- Updating require for linux_admin to at least v0.9.3

* Wed Dec 03 2014 John Prause <jprause@redhat.com> - 5.3.2.1-1
- Building 5.3.2.1 with RHEL66 for 5.3.z release and QE

* Wed Nov 12 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.1.10-1
- Building 5.3.1.10 with RHEL66 for 5.3.z release

* Tue Nov 04 2014 John Prause <john.prause@redhat.com> - 5.3.1.9-1
- Building 5.3.1.9 with RHEL66 for 5.3.z release

* Thu Oct 30 2014 John Prause <john.prause@redhat.com> - 5.3.1.8-1
- Building 5.3.1.8 with RHEL66 for 5.3.z release

* Tue Oct 28 2014 John Prause <john.prause@redhat.com> - 5.3.1.6-1
- Building 5.3.1.6 with RHEL66 for 5.3.z

* Thu Oct 16 2014 John Prause <john.prause@redhat.com> - 5.3.1.2-1
- Building 5.3.1.2 with RHEL65 for initial testing

* Wed Oct 15 2014 Joe Vlcek <jvlcek@redhat.com> - 5.3.0.15-2
- Copy system/COPY/var to buildroot for support for Kerberos Ticket based Single Sign-On

* Mon Sep 29 2014 John Prause <john.prause@redhat.com> - 5.3.0.15-1
- Building 5.3.0.15 for QE final testing before release. Picking up last fixes and the 2nd bash fix.

* Thu Sep 25 2014 John Prause <john.prause@redhat.com> - 5.3.0.14-1
- Building 5.3.0.14 for QE final testing before release. Skipped .13 in tagging.

* Fri Sep 19 2014 John Prause <john.prause@redhat.com> - 5.3.0.12-1
- Building 5.3.0.12 for QE testing.

* Tue Sep 16 2014 John Prause <john.prause@redhat.com> - 5.3.0.11-1
- Building 5.3.0.11 for QE testing.

* Fri Sep 12 2014 John Prause <john.prause@redhat.com> - 5.3.0.10-1
- Building 5.3.0.10 for QE testing.

* Thu Sep 11 2014 John Prause <john.prause@redhat.com> - 5.3.0.8-2
- Building 5.3.0.8 for QE testing.

* Wed Sep 10 2014 John Prause <john.prause@redhat.com> - 5.3.0.8-1
- Building 5.3.0.8 for QE testing.

* Fri Sep 05 2014 John Prause <john.prause@redhat.com> - 5.3.0.7-1
- Building 5.3.0.7 for QE testing.

* Fri Aug 29 2014 John Prause <john.prause@redhat.com> - 5.3.0.6-1
- Building 5.3.0.6 for QE testing.

* Fri Aug 22 2014 John Prause <john.prause@redhat.com> - 5.3.0.5-2
- Building 5.3.0 Beta2 but this time excluding the ca directory.

* Fri Aug 22 2014 John Prause <john.prause@redhat.com> - 5.3.0.5-1
- Building 5.3.0 Beta2

* Tue Aug 05 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.2-3
- Try adding sssd package as a require to ensure ipa-client meets it's require
- sssd >= 1.9.2-25 for package: ipa-client-3.0.0-37.el6.x86_64

* Tue Aug 05 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.2-2
- Smoke and mirrors.
- Move the sssd-dbus dependency into cfme-appliance package to force it to resolve first.

* Tue Aug 05 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.2-1
- Rebase to new 5.3.0.2 to include tarball creation fix.
- Revise 5.3.0.0-14.alpha6 changelog to escape macro using "%%".

* Tue Aug 05 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.1-2
- Prior tarball included undesired artifacts from running asset precompilation.
- See: https://github.com/ManageIQ/manageiq/pull/341

* Mon Aug 04 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.1-1
- Add identity packages.
- Rebase to new branch/tag.

* Fri Aug 01 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.0-18.alpha9
- Update to 5.3.0.0-alpha9.
- Loosen frequently updated dependencies.

* Wed Jul 30 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.0-17.alpha8
- Add qpid-cpp-client-ssl for https://bugzilla.redhat.com/show_bug.cgi?id=1118902
- Use newer sprockets
- Remove building of the vddk c binding

* Thu Jul 10 2014 John Prause <jprause@redhat.com> - 5.3.0.0-16.alpha8
- Update for 5.3.0.0-16-alpha8 build

* Mon Jun 23 2014 John Prause <jprause@redhat.com> - 5.3.0.0-14.alpha7
- Update for 5.3.0.0-14-alpha7 build

* Tue May 27 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-14.alpha6
- Include the ca buildroot/app_root directory

* Thu May 22 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-13.alpha6
- Update for 5.3.0.0-13-alpha6 build

* Fri May 16 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.0.0-12.alpha5
- Update spec to remove files no longer included for logrotate.
- https://github.com/ManageIQ/cfme/pull/2269

* Fri May 16 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.0.0-11.alpha5
- TRUNCATED CHANGELOG See git history or cfme-5.2-rhel-6 branch for older changes

* Tue May 13 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-10.alpha5
- Fix jbuilder Requires typo

* Mon May 12 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-9.alpha5
- Update for 5.3.0.0-9-alpha5 build

* Tue Apr 22 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.0-8.alpha4
- Added BuildRequires for rake.
- Added rake build:shared_objects feature to eliminate duplication.
- For testing, added tarball from upstream sources at: https://github.com/ManageIQ/cfme/pull/2111

* Mon Apr 14 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-7.alpha4
- Fix build from 5.3.0.0-6-alpha3 5.3.0.0-7-alpha4 build

* Mon Apr 14 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-6.alpha4
- Update for 5.3.0.0-6-alpha4 build

* Fri Apr 11 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-5.alpha3
- Update for 5.3.0.0-5-alpha3 build

* Fri Apr 04 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-4.alpha2
- Restore ruby193-rubygem-amq-protocol and ruby193-rubygem-bunny

* Thu Apr 03 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-3.alpha2
- Fix excon - for real this time

* Thu Apr 03 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-2.alpha2
- Fix versions for fog and excon

* Wed Apr 02 2014 Joe VLcek <jvlcek@redhat.com> - 5.3.0.0-1.alpha2
- Update for 5.3.0.0-1-alpha2 build

* Tue Apr 01 2014 Joe Rafaniello <jrafanie@redhat.com> - 5.3.0.0-1.alpha1
- Fix Prince PDF license file "Installed (but unpackaged) file(s) found" error.

* Fri Mar 28 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.0.0-1.alpha1
- Remove Gemfile.appliance_excludes.rb exclusion out of spec
- https://github.com/ManageIQ/cfme/pull/1969

* Mon Mar 10 2014 Brandon Dunne <bdunne@redhat.com> - 5.3.0.0-1.alpha1
- set up symlink for Prince PDF license file.
